/* Code generated by IfcQuery EXPRESS generator, www.ifcquery.com */
#include "ifcpp/model/AttributeObject.h"
#include "ifcpp/model/BuildingException.h"
#include "ifcpp/model/BuildingGuid.h"
#include "ifcpp/reader/ReaderUtil.h"
#include "ifcpp/writer/WriterUtil.h"
#include "ifcpp/IFC4X3/include/IfcColourRgbList.h"
#include "ifcpp/IFC4X3/include/IfcIndexedColourMap.h"
#include "ifcpp/IFC4X3/include/IfcNormalisedRatioMeasure.h"
#include "ifcpp/IFC4X3/include/IfcPositiveInteger.h"
#include "ifcpp/IFC4X3/include/IfcTessellatedFaceSet.h"

// ENTITY IfcIndexedColourMap 
IFC4X3::IfcIndexedColourMap::IfcIndexedColourMap( int tag ) { m_tag = tag; }
void IFC4X3::IfcIndexedColourMap::getStepLine( std::stringstream& stream, size_t precision ) const
{
	stream << "#" << m_tag << "=IFCINDEXEDCOLOURMAP" << "(";
	if( m_MappedTo ) { stream << "#" << m_MappedTo->m_tag; } else { stream << "$"; }
	stream << ",";
	if( m_Opacity ) { m_Opacity->getStepParameter( stream, false, precision ); } else { stream << "$"; }
	stream << ",";
	if( m_Colours ) { stream << "#" << m_Colours->m_tag; } else { stream << "$"; }
	stream << ",";
	stream << "(";
	for( size_t ii = 0; ii < m_ColourIndex.size(); ++ii )
	{
		if( ii > 0 )
		{
			stream << ",";
		}
		const shared_ptr<IfcPositiveInteger>& type_object = m_ColourIndex[ii];
		if( type_object )
		{
			type_object->getStepParameter( stream, false, precision );
		}
		else
		{
			stream << "$";
		}
	}
	stream << ")";
	stream << ");";
}
void IFC4X3::IfcIndexedColourMap::getStepParameter( std::stringstream& stream, bool /*is_select_type*/, size_t /*precision*/ ) const { stream << "#" << m_tag; }
void IFC4X3::IfcIndexedColourMap::readStepArguments( const std::vector<std::string>& args, const BuildingModelMapType<int,shared_ptr<BuildingEntity> >& map, std::stringstream& errorStream, std::unordered_set<int>& entityIdNotFound )
{
	const size_t num_args = args.size();
	if( num_args > 0 ){readEntityReference( args[0], m_MappedTo, map, errorStream, entityIdNotFound );}
	if( num_args > 1 ){m_Opacity = IfcNormalisedRatioMeasure::createObjectFromSTEP( args[1], map, errorStream, entityIdNotFound );}
	if( num_args > 2 ){readEntityReference( args[2], m_Colours, map, errorStream, entityIdNotFound );}
	if( num_args > 3 ){readTypeOfIntegerList( args[3], m_ColourIndex );}
	if( num_args != 4 ){ errorStream << "Wrong parameter count for entity IfcIndexedColourMap, expecting 4, having " << num_args << ". Entity ID: " << m_tag << std::endl; }
}
void IFC4X3::IfcIndexedColourMap::getAttributes( std::vector<std::pair<std::string, shared_ptr<BuildingObject> > >& vec_attributes ) const
{
	IFC4X3::IfcPresentationItem::getAttributes( vec_attributes );
	vec_attributes.emplace_back( std::make_pair( "MappedTo", m_MappedTo ) );
	vec_attributes.emplace_back( std::make_pair( "Opacity", m_Opacity ) );
	vec_attributes.emplace_back( std::make_pair( "Colours", m_Colours ) );
	shared_ptr<AttributeObjectVector> ColourIndex_vec_object( new AttributeObjectVector() );
	std::copy( m_ColourIndex.begin(), m_ColourIndex.end(), std::back_inserter( ColourIndex_vec_object->m_vec ) );
	vec_attributes.emplace_back( std::make_pair( "ColourIndex", ColourIndex_vec_object ) );
}
void IFC4X3::IfcIndexedColourMap::getAttributesInverse( std::vector<std::pair<std::string, shared_ptr<BuildingObject> > >& vec_attributes_inverse ) const
{
	IFC4X3::IfcPresentationItem::getAttributesInverse( vec_attributes_inverse );
}
void IFC4X3::IfcIndexedColourMap::setInverseCounterparts( shared_ptr<BuildingEntity> ptr_self_entity )
{
	IfcPresentationItem::setInverseCounterparts( ptr_self_entity );
	shared_ptr<IfcIndexedColourMap> ptr_self = dynamic_pointer_cast<IfcIndexedColourMap>( ptr_self_entity );
	if( !ptr_self ) { throw BuildingException( "IfcIndexedColourMap::setInverseCounterparts: type mismatch" ); }
	if( m_MappedTo )
	{
		m_MappedTo->m_HasColours_inverse.emplace_back( ptr_self );
	}
}
void IFC4X3::IfcIndexedColourMap::unlinkFromInverseCounterparts()
{
	IfcPresentationItem::unlinkFromInverseCounterparts();
	if( m_MappedTo )
	{
		std::vector<weak_ptr<IfcIndexedColourMap> >& HasColours_inverse = m_MappedTo->m_HasColours_inverse;
		for( auto it_HasColours_inverse = HasColours_inverse.begin(); it_HasColours_inverse != HasColours_inverse.end(); )
		{
			weak_ptr<IfcIndexedColourMap> self_candidate_weak = *it_HasColours_inverse;
			if( self_candidate_weak.expired() )
			{
				++it_HasColours_inverse;
				continue;
			}
			shared_ptr<IfcIndexedColourMap> self_candidate( *it_HasColours_inverse );
			if( self_candidate.get() == this )
			{
				it_HasColours_inverse= HasColours_inverse.erase( it_HasColours_inverse );
			}
			else
			{
				++it_HasColours_inverse;
			}
		}
	}
}
