/* Code generated by IfcQuery EXPRESS generator, www.ifcquery.com */
#include "ifcpp/model/AttributeObject.h"
#include "ifcpp/model/BuildingException.h"
#include "ifcpp/model/BuildingGuid.h"
#include "ifcpp/reader/ReaderUtil.h"
#include "ifcpp/writer/WriterUtil.h"
#include "ifcpp/IFC4X3/include/IfcDayInMonthNumber.h"
#include "ifcpp/IFC4X3/include/IfcDayInWeekNumber.h"
#include "ifcpp/IFC4X3/include/IfcInteger.h"
#include "ifcpp/IFC4X3/include/IfcMonthInYearNumber.h"
#include "ifcpp/IFC4X3/include/IfcRecurrencePattern.h"
#include "ifcpp/IFC4X3/include/IfcRecurrenceTypeEnum.h"
#include "ifcpp/IFC4X3/include/IfcTimePeriod.h"

// ENTITY IfcRecurrencePattern 
IFC4X3::IfcRecurrencePattern::IfcRecurrencePattern( int tag ) { m_tag = tag; }
void IFC4X3::IfcRecurrencePattern::getStepLine( std::stringstream& stream, size_t precision ) const
{
	stream << "#" << m_tag << "=IFCRECURRENCEPATTERN" << "(";
	if( m_RecurrenceType ) { m_RecurrenceType->getStepParameter( stream, false, precision ); } else { stream << "$"; }
	stream << ",";
	writeTypeOfIntList( stream, m_DayComponent, true );
	stream << ",";
	writeTypeOfIntList( stream, m_WeekdayComponent, true );
	stream << ",";
	writeTypeOfIntList( stream, m_MonthComponent, true );
	stream << ",";
	if( m_Position ) { m_Position->getStepParameter( stream, false, precision ); } else { stream << "$"; }
	stream << ",";
	if( m_Interval ) { m_Interval->getStepParameter( stream, false, precision ); } else { stream << "$"; }
	stream << ",";
	if( m_Occurrences ) { m_Occurrences->getStepParameter( stream, false, precision ); } else { stream << "$"; }
	stream << ",";
	writeEntityList( stream, m_TimePeriods );
	stream << ");";
}
void IFC4X3::IfcRecurrencePattern::getStepParameter( std::stringstream& stream, bool /*is_select_type*/, size_t /*precision*/ ) const { stream << "#" << m_tag; }
void IFC4X3::IfcRecurrencePattern::readStepArguments( const std::vector<std::string>& args, const BuildingModelMapType<int,shared_ptr<BuildingEntity> >& map, std::stringstream& errorStream, std::unordered_set<int>& entityIdNotFound )
{
	const size_t num_args = args.size();
	if( num_args > 0 ){m_RecurrenceType = IfcRecurrenceTypeEnum::createObjectFromSTEP( args[0], map, errorStream, entityIdNotFound );}
	if( num_args > 1 ){readTypeOfIntegerList( args[1], m_DayComponent );}
	if( num_args > 2 ){readTypeOfIntegerList( args[2], m_WeekdayComponent );}
	if( num_args > 3 ){readTypeOfIntegerList( args[3], m_MonthComponent );}
	if( num_args > 4 ){m_Position = IfcInteger::createObjectFromSTEP( args[4], map, errorStream, entityIdNotFound );}
	if( num_args > 5 ){m_Interval = IfcInteger::createObjectFromSTEP( args[5], map, errorStream, entityIdNotFound );}
	if( num_args > 6 ){m_Occurrences = IfcInteger::createObjectFromSTEP( args[6], map, errorStream, entityIdNotFound );}
	if( num_args > 7 ){readEntityReferenceList( args[7], m_TimePeriods, map, errorStream, entityIdNotFound );}
	if( num_args != 8 ){ errorStream << "Wrong parameter count for entity IfcRecurrencePattern, expecting 8, having " << num_args << ". Entity ID: " << m_tag << std::endl; }
}
void IFC4X3::IfcRecurrencePattern::getAttributes( std::vector<std::pair<std::string, shared_ptr<BuildingObject> > >& vec_attributes ) const
{
	vec_attributes.emplace_back( std::make_pair( "RecurrenceType", m_RecurrenceType ) );
	shared_ptr<AttributeObjectVector> DayComponent_vec_object( new AttributeObjectVector() );
	std::copy( m_DayComponent.begin(), m_DayComponent.end(), std::back_inserter( DayComponent_vec_object->m_vec ) );
	vec_attributes.emplace_back( std::make_pair( "DayComponent", DayComponent_vec_object ) );
	shared_ptr<AttributeObjectVector> WeekdayComponent_vec_object( new AttributeObjectVector() );
	std::copy( m_WeekdayComponent.begin(), m_WeekdayComponent.end(), std::back_inserter( WeekdayComponent_vec_object->m_vec ) );
	vec_attributes.emplace_back( std::make_pair( "WeekdayComponent", WeekdayComponent_vec_object ) );
	shared_ptr<AttributeObjectVector> MonthComponent_vec_object( new AttributeObjectVector() );
	std::copy( m_MonthComponent.begin(), m_MonthComponent.end(), std::back_inserter( MonthComponent_vec_object->m_vec ) );
	vec_attributes.emplace_back( std::make_pair( "MonthComponent", MonthComponent_vec_object ) );
	vec_attributes.emplace_back( std::make_pair( "Position", m_Position ) );
	vec_attributes.emplace_back( std::make_pair( "Interval", m_Interval ) );
	vec_attributes.emplace_back( std::make_pair( "Occurrences", m_Occurrences ) );
	shared_ptr<AttributeObjectVector> TimePeriods_vec_object( new AttributeObjectVector() );
	std::copy( m_TimePeriods.begin(), m_TimePeriods.end(), std::back_inserter( TimePeriods_vec_object->m_vec ) );
	vec_attributes.emplace_back( std::make_pair( "TimePeriods", TimePeriods_vec_object ) );
}
void IFC4X3::IfcRecurrencePattern::getAttributesInverse( std::vector<std::pair<std::string, shared_ptr<BuildingObject> > >& vec_attributes_inverse ) const
{
}
void IFC4X3::IfcRecurrencePattern::setInverseCounterparts( shared_ptr<BuildingEntity> )
{
}
void IFC4X3::IfcRecurrencePattern::unlinkFromInverseCounterparts()
{
}
