/* Code generated by IfcQuery EXPRESS generator, www.ifcquery.com */
#include "ifcpp/model/AttributeObject.h"
#include "ifcpp/model/BuildingException.h"
#include "ifcpp/model/BuildingGuid.h"
#include "ifcpp/reader/ReaderUtil.h"
#include "ifcpp/writer/WriterUtil.h"
#include "ifcpp/IFC4X3/include/IfcElement.h"
#include "ifcpp/IFC4X3/include/IfcGloballyUniqueId.h"
#include "ifcpp/IFC4X3/include/IfcLabel.h"
#include "ifcpp/IFC4X3/include/IfcOwnerHistory.h"
#include "ifcpp/IFC4X3/include/IfcRelAdheresToElement.h"
#include "ifcpp/IFC4X3/include/IfcSurfaceFeature.h"
#include "ifcpp/IFC4X3/include/IfcText.h"

// ENTITY IfcRelAdheresToElement 
IFC4X3::IfcRelAdheresToElement::IfcRelAdheresToElement( int tag ) { m_tag = tag; }
void IFC4X3::IfcRelAdheresToElement::getStepLine( std::stringstream& stream, size_t precision ) const
{
	stream << "#" << m_tag << "=IFCRELADHERESTOELEMENT" << "(";
	if( m_GlobalId ) { m_GlobalId->getStepParameter( stream, false, precision ); } else { stream << "$"; }
	stream << ",";
	if( m_OwnerHistory ) { stream << "#" << m_OwnerHistory->m_tag; } else { stream << "$"; }
	stream << ",";
	if( m_Name ) { m_Name->getStepParameter( stream, false, precision ); } else { stream << "$"; }
	stream << ",";
	if( m_Description ) { m_Description->getStepParameter( stream, false, precision ); } else { stream << "$"; }
	stream << ",";
	if( m_RelatingElement ) { stream << "#" << m_RelatingElement->m_tag; } else { stream << "$"; }
	stream << ",";
	writeEntityList( stream, m_RelatedSurfaceFeatures );
	stream << ");";
}
void IFC4X3::IfcRelAdheresToElement::getStepParameter( std::stringstream& stream, bool /*is_select_type*/, size_t /*precision*/ ) const { stream << "#" << m_tag; }
void IFC4X3::IfcRelAdheresToElement::readStepArguments( const std::vector<std::string>& args, const BuildingModelMapType<int,shared_ptr<BuildingEntity> >& map, std::stringstream& errorStream, std::unordered_set<int>& entityIdNotFound )
{
	const size_t num_args = args.size();
	if( num_args > 0 ){m_GlobalId = IfcGloballyUniqueId::createObjectFromSTEP( args[0], map, errorStream, entityIdNotFound );}
	if( num_args > 1 ){readEntityReference( args[1], m_OwnerHistory, map, errorStream, entityIdNotFound );}
	if( num_args > 2 ){m_Name = IfcLabel::createObjectFromSTEP( args[2], map, errorStream, entityIdNotFound );}
	if( num_args > 3 ){m_Description = IfcText::createObjectFromSTEP( args[3], map, errorStream, entityIdNotFound );}
	if( num_args > 4 ){readEntityReference( args[4], m_RelatingElement, map, errorStream, entityIdNotFound );}
	if( num_args > 5 ){readEntityReferenceList( args[5], m_RelatedSurfaceFeatures, map, errorStream, entityIdNotFound );}
	if( num_args != 6 ){ errorStream << "Wrong parameter count for entity IfcRelAdheresToElement, expecting 6, having " << num_args << ". Entity ID: " << m_tag << std::endl; }
}
void IFC4X3::IfcRelAdheresToElement::getAttributes( std::vector<std::pair<std::string, shared_ptr<BuildingObject> > >& vec_attributes ) const
{
	IFC4X3::IfcRelDecomposes::getAttributes( vec_attributes );
	vec_attributes.emplace_back( std::make_pair( "RelatingElement", m_RelatingElement ) );
	shared_ptr<AttributeObjectVector> RelatedSurfaceFeatures_vec_object( new AttributeObjectVector() );
	std::copy( m_RelatedSurfaceFeatures.begin(), m_RelatedSurfaceFeatures.end(), std::back_inserter( RelatedSurfaceFeatures_vec_object->m_vec ) );
	vec_attributes.emplace_back( std::make_pair( "RelatedSurfaceFeatures", RelatedSurfaceFeatures_vec_object ) );
}
void IFC4X3::IfcRelAdheresToElement::getAttributesInverse( std::vector<std::pair<std::string, shared_ptr<BuildingObject> > >& vec_attributes_inverse ) const
{
	IFC4X3::IfcRelDecomposes::getAttributesInverse( vec_attributes_inverse );
}
void IFC4X3::IfcRelAdheresToElement::setInverseCounterparts( shared_ptr<BuildingEntity> ptr_self_entity )
{
	IfcRelDecomposes::setInverseCounterparts( ptr_self_entity );
	shared_ptr<IfcRelAdheresToElement> ptr_self = dynamic_pointer_cast<IfcRelAdheresToElement>( ptr_self_entity );
	if( !ptr_self ) { throw BuildingException( "IfcRelAdheresToElement::setInverseCounterparts: type mismatch" ); }
	for( size_t i=0; i<m_RelatedSurfaceFeatures.size(); ++i )
	{
		if( m_RelatedSurfaceFeatures[i] )
		{
			m_RelatedSurfaceFeatures[i]->m_AdheresToElement_inverse = ptr_self;
		}
	}
	if( m_RelatingElement )
	{
		m_RelatingElement->m_HasSurfaceFeatures_inverse.emplace_back( ptr_self );
	}
}
void IFC4X3::IfcRelAdheresToElement::unlinkFromInverseCounterparts()
{
	IfcRelDecomposes::unlinkFromInverseCounterparts();
	for( size_t i=0; i<m_RelatedSurfaceFeatures.size(); ++i )
	{
		if( m_RelatedSurfaceFeatures[i] )
		{
			if( !m_RelatedSurfaceFeatures[i]->m_AdheresToElement_inverse.expired() )
			{
				shared_ptr<IfcRelAdheresToElement> self_candidate( m_RelatedSurfaceFeatures[i]->m_AdheresToElement_inverse );
				if( self_candidate.get() == this )
				{
					weak_ptr<IfcRelAdheresToElement>& self_candidate_weak = m_RelatedSurfaceFeatures[i]->m_AdheresToElement_inverse;
					self_candidate_weak.reset();
				}
			}
		}
	}
	if( m_RelatingElement )
	{
		std::vector<weak_ptr<IfcRelAdheresToElement> >& HasSurfaceFeatures_inverse = m_RelatingElement->m_HasSurfaceFeatures_inverse;
		for( auto it_HasSurfaceFeatures_inverse = HasSurfaceFeatures_inverse.begin(); it_HasSurfaceFeatures_inverse != HasSurfaceFeatures_inverse.end(); )
		{
			weak_ptr<IfcRelAdheresToElement> self_candidate_weak = *it_HasSurfaceFeatures_inverse;
			if( self_candidate_weak.expired() )
			{
				++it_HasSurfaceFeatures_inverse;
				continue;
			}
			shared_ptr<IfcRelAdheresToElement> self_candidate( *it_HasSurfaceFeatures_inverse );
			if( self_candidate.get() == this )
			{
				it_HasSurfaceFeatures_inverse= HasSurfaceFeatures_inverse.erase( it_HasSurfaceFeatures_inverse );
			}
			else
			{
				++it_HasSurfaceFeatures_inverse;
			}
		}
	}
}
