/* Code generated by IfcQuery EXPRESS generator, www.ifcquery.com */
#include "ifcpp/model/AttributeObject.h"
#include "ifcpp/model/BuildingException.h"
#include "ifcpp/model/BuildingGuid.h"
#include "ifcpp/reader/ReaderUtil.h"
#include "ifcpp/writer/WriterUtil.h"
#include "ifcpp/IFC4X3/include/IfcGloballyUniqueId.h"
#include "ifcpp/IFC4X3/include/IfcLabel.h"
#include "ifcpp/IFC4X3/include/IfcOwnerHistory.h"
#include "ifcpp/IFC4X3/include/IfcPositioningElement.h"
#include "ifcpp/IFC4X3/include/IfcProduct.h"
#include "ifcpp/IFC4X3/include/IfcRelPositions.h"
#include "ifcpp/IFC4X3/include/IfcText.h"

// ENTITY IfcRelPositions 
IFC4X3::IfcRelPositions::IfcRelPositions( int tag ) { m_tag = tag; }
void IFC4X3::IfcRelPositions::getStepLine( std::stringstream& stream, size_t precision ) const
{
	stream << "#" << m_tag << "=IFCRELPOSITIONS" << "(";
	if( m_GlobalId ) { m_GlobalId->getStepParameter( stream, false, precision ); } else { stream << "$"; }
	stream << ",";
	if( m_OwnerHistory ) { stream << "#" << m_OwnerHistory->m_tag; } else { stream << "$"; }
	stream << ",";
	if( m_Name ) { m_Name->getStepParameter( stream, false, precision ); } else { stream << "$"; }
	stream << ",";
	if( m_Description ) { m_Description->getStepParameter( stream, false, precision ); } else { stream << "$"; }
	stream << ",";
	if( m_RelatingPositioningElement ) { stream << "#" << m_RelatingPositioningElement->m_tag; } else { stream << "$"; }
	stream << ",";
	writeEntityList( stream, m_RelatedProducts );
	stream << ");";
}
void IFC4X3::IfcRelPositions::getStepParameter( std::stringstream& stream, bool /*is_select_type*/, size_t /*precision*/ ) const { stream << "#" << m_tag; }
void IFC4X3::IfcRelPositions::readStepArguments( const std::vector<std::string>& args, const BuildingModelMapType<int,shared_ptr<BuildingEntity> >& map, std::stringstream& errorStream, std::unordered_set<int>& entityIdNotFound )
{
	const size_t num_args = args.size();
	if( num_args > 0 ){m_GlobalId = IfcGloballyUniqueId::createObjectFromSTEP( args[0], map, errorStream, entityIdNotFound );}
	if( num_args > 1 ){readEntityReference( args[1], m_OwnerHistory, map, errorStream, entityIdNotFound );}
	if( num_args > 2 ){m_Name = IfcLabel::createObjectFromSTEP( args[2], map, errorStream, entityIdNotFound );}
	if( num_args > 3 ){m_Description = IfcText::createObjectFromSTEP( args[3], map, errorStream, entityIdNotFound );}
	if( num_args > 4 ){readEntityReference( args[4], m_RelatingPositioningElement, map, errorStream, entityIdNotFound );}
	if( num_args > 5 ){readEntityReferenceList( args[5], m_RelatedProducts, map, errorStream, entityIdNotFound );}
	if( num_args != 6 ){ errorStream << "Wrong parameter count for entity IfcRelPositions, expecting 6, having " << num_args << ". Entity ID: " << m_tag << std::endl; }
}
void IFC4X3::IfcRelPositions::getAttributes( std::vector<std::pair<std::string, shared_ptr<BuildingObject> > >& vec_attributes ) const
{
	IFC4X3::IfcRelConnects::getAttributes( vec_attributes );
	vec_attributes.emplace_back( std::make_pair( "RelatingPositioningElement", m_RelatingPositioningElement ) );
	shared_ptr<AttributeObjectVector> RelatedProducts_vec_object( new AttributeObjectVector() );
	std::copy( m_RelatedProducts.begin(), m_RelatedProducts.end(), std::back_inserter( RelatedProducts_vec_object->m_vec ) );
	vec_attributes.emplace_back( std::make_pair( "RelatedProducts", RelatedProducts_vec_object ) );
}
void IFC4X3::IfcRelPositions::getAttributesInverse( std::vector<std::pair<std::string, shared_ptr<BuildingObject> > >& vec_attributes_inverse ) const
{
	IFC4X3::IfcRelConnects::getAttributesInverse( vec_attributes_inverse );
}
void IFC4X3::IfcRelPositions::setInverseCounterparts( shared_ptr<BuildingEntity> ptr_self_entity )
{
	IfcRelConnects::setInverseCounterparts( ptr_self_entity );
	shared_ptr<IfcRelPositions> ptr_self = dynamic_pointer_cast<IfcRelPositions>( ptr_self_entity );
	if( !ptr_self ) { throw BuildingException( "IfcRelPositions::setInverseCounterparts: type mismatch" ); }
	for( size_t i=0; i<m_RelatedProducts.size(); ++i )
	{
		if( m_RelatedProducts[i] )
		{
			m_RelatedProducts[i]->m_PositionedRelativeTo_inverse.emplace_back( ptr_self );
		}
	}
	if( m_RelatingPositioningElement )
	{
		m_RelatingPositioningElement->m_Positions_inverse.emplace_back( ptr_self );
	}
}
void IFC4X3::IfcRelPositions::unlinkFromInverseCounterparts()
{
	IfcRelConnects::unlinkFromInverseCounterparts();
	for( size_t i=0; i<m_RelatedProducts.size(); ++i )
	{
		if( m_RelatedProducts[i] )
		{
			std::vector<weak_ptr<IfcRelPositions> >& PositionedRelativeTo_inverse = m_RelatedProducts[i]->m_PositionedRelativeTo_inverse;
			for( auto it_PositionedRelativeTo_inverse = PositionedRelativeTo_inverse.begin(); it_PositionedRelativeTo_inverse != PositionedRelativeTo_inverse.end(); )
			{
				weak_ptr<IfcRelPositions> self_candidate_weak = *it_PositionedRelativeTo_inverse;
				if( self_candidate_weak.expired() )
				{
					++it_PositionedRelativeTo_inverse;
					continue;
				}
				shared_ptr<IfcRelPositions> self_candidate( *it_PositionedRelativeTo_inverse );
				if( self_candidate.get() == this )
				{
					it_PositionedRelativeTo_inverse= PositionedRelativeTo_inverse.erase( it_PositionedRelativeTo_inverse );
				}
				else
				{
					++it_PositionedRelativeTo_inverse;
				}
			}
		}
	}
	if( m_RelatingPositioningElement )
	{
		std::vector<weak_ptr<IfcRelPositions> >& Positions_inverse = m_RelatingPositioningElement->m_Positions_inverse;
		for( auto it_Positions_inverse = Positions_inverse.begin(); it_Positions_inverse != Positions_inverse.end(); )
		{
			weak_ptr<IfcRelPositions> self_candidate_weak = *it_Positions_inverse;
			if( self_candidate_weak.expired() )
			{
				++it_Positions_inverse;
				continue;
			}
			shared_ptr<IfcRelPositions> self_candidate( *it_Positions_inverse );
			if( self_candidate.get() == this )
			{
				it_Positions_inverse= Positions_inverse.erase( it_Positions_inverse );
			}
			else
			{
				++it_Positions_inverse;
			}
		}
	}
}
