/* Code generated by IfcQuery EXPRESS generator, www.ifcquery.com */
#include "ifcpp/model/AttributeObject.h"
#include "ifcpp/model/BuildingException.h"
#include "ifcpp/model/BuildingGuid.h"
#include "ifcpp/reader/ReaderUtil.h"
#include "ifcpp/writer/WriterUtil.h"
#include "ifcpp/IFC4X3/include/IfcGloballyUniqueId.h"
#include "ifcpp/IFC4X3/include/IfcLabel.h"
#include "ifcpp/IFC4X3/include/IfcLagTime.h"
#include "ifcpp/IFC4X3/include/IfcOwnerHistory.h"
#include "ifcpp/IFC4X3/include/IfcProcess.h"
#include "ifcpp/IFC4X3/include/IfcRelSequence.h"
#include "ifcpp/IFC4X3/include/IfcSequenceEnum.h"
#include "ifcpp/IFC4X3/include/IfcText.h"

// ENTITY IfcRelSequence 
IFC4X3::IfcRelSequence::IfcRelSequence( int tag ) { m_tag = tag; }
void IFC4X3::IfcRelSequence::getStepLine( std::stringstream& stream, size_t precision ) const
{
	stream << "#" << m_tag << "=IFCRELSEQUENCE" << "(";
	if( m_GlobalId ) { m_GlobalId->getStepParameter( stream, false, precision ); } else { stream << "$"; }
	stream << ",";
	if( m_OwnerHistory ) { stream << "#" << m_OwnerHistory->m_tag; } else { stream << "$"; }
	stream << ",";
	if( m_Name ) { m_Name->getStepParameter( stream, false, precision ); } else { stream << "$"; }
	stream << ",";
	if( m_Description ) { m_Description->getStepParameter( stream, false, precision ); } else { stream << "$"; }
	stream << ",";
	if( m_RelatingProcess ) { stream << "#" << m_RelatingProcess->m_tag; } else { stream << "$"; }
	stream << ",";
	if( m_RelatedProcess ) { stream << "#" << m_RelatedProcess->m_tag; } else { stream << "$"; }
	stream << ",";
	if( m_TimeLag ) { stream << "#" << m_TimeLag->m_tag; } else { stream << "$"; }
	stream << ",";
	if( m_SequenceType ) { m_SequenceType->getStepParameter( stream, false, precision ); } else { stream << "$"; }
	stream << ",";
	if( m_UserDefinedSequenceType ) { m_UserDefinedSequenceType->getStepParameter( stream, false, precision ); } else { stream << "$"; }
	stream << ");";
}
void IFC4X3::IfcRelSequence::getStepParameter( std::stringstream& stream, bool /*is_select_type*/, size_t /*precision*/ ) const { stream << "#" << m_tag; }
void IFC4X3::IfcRelSequence::readStepArguments( const std::vector<std::string>& args, const BuildingModelMapType<int,shared_ptr<BuildingEntity> >& map, std::stringstream& errorStream, std::unordered_set<int>& entityIdNotFound )
{
	const size_t num_args = args.size();
	if( num_args > 0 ){m_GlobalId = IfcGloballyUniqueId::createObjectFromSTEP( args[0], map, errorStream, entityIdNotFound );}
	if( num_args > 1 ){readEntityReference( args[1], m_OwnerHistory, map, errorStream, entityIdNotFound );}
	if( num_args > 2 ){m_Name = IfcLabel::createObjectFromSTEP( args[2], map, errorStream, entityIdNotFound );}
	if( num_args > 3 ){m_Description = IfcText::createObjectFromSTEP( args[3], map, errorStream, entityIdNotFound );}
	if( num_args > 4 ){readEntityReference( args[4], m_RelatingProcess, map, errorStream, entityIdNotFound );}
	if( num_args > 5 ){readEntityReference( args[5], m_RelatedProcess, map, errorStream, entityIdNotFound );}
	if( num_args > 6 ){readEntityReference( args[6], m_TimeLag, map, errorStream, entityIdNotFound );}
	if( num_args > 7 ){m_SequenceType = IfcSequenceEnum::createObjectFromSTEP( args[7], map, errorStream, entityIdNotFound );}
	if( num_args > 8 ){m_UserDefinedSequenceType = IfcLabel::createObjectFromSTEP( args[8], map, errorStream, entityIdNotFound );}
	if( num_args != 9 ){ errorStream << "Wrong parameter count for entity IfcRelSequence, expecting 9, having " << num_args << ". Entity ID: " << m_tag << std::endl; }
}
void IFC4X3::IfcRelSequence::getAttributes( std::vector<std::pair<std::string, shared_ptr<BuildingObject> > >& vec_attributes ) const
{
	IFC4X3::IfcRelConnects::getAttributes( vec_attributes );
	vec_attributes.emplace_back( std::make_pair( "RelatingProcess", m_RelatingProcess ) );
	vec_attributes.emplace_back( std::make_pair( "RelatedProcess", m_RelatedProcess ) );
	vec_attributes.emplace_back( std::make_pair( "TimeLag", m_TimeLag ) );
	vec_attributes.emplace_back( std::make_pair( "SequenceType", m_SequenceType ) );
	vec_attributes.emplace_back( std::make_pair( "UserDefinedSequenceType", m_UserDefinedSequenceType ) );
}
void IFC4X3::IfcRelSequence::getAttributesInverse( std::vector<std::pair<std::string, shared_ptr<BuildingObject> > >& vec_attributes_inverse ) const
{
	IFC4X3::IfcRelConnects::getAttributesInverse( vec_attributes_inverse );
}
void IFC4X3::IfcRelSequence::setInverseCounterparts( shared_ptr<BuildingEntity> ptr_self_entity )
{
	IfcRelConnects::setInverseCounterparts( ptr_self_entity );
	shared_ptr<IfcRelSequence> ptr_self = dynamic_pointer_cast<IfcRelSequence>( ptr_self_entity );
	if( !ptr_self ) { throw BuildingException( "IfcRelSequence::setInverseCounterparts: type mismatch" ); }
	if( m_RelatedProcess )
	{
		m_RelatedProcess->m_IsSuccessorFrom_inverse.emplace_back( ptr_self );
	}
	if( m_RelatingProcess )
	{
		m_RelatingProcess->m_IsPredecessorTo_inverse.emplace_back( ptr_self );
	}
}
void IFC4X3::IfcRelSequence::unlinkFromInverseCounterparts()
{
	IfcRelConnects::unlinkFromInverseCounterparts();
	if( m_RelatedProcess )
	{
		std::vector<weak_ptr<IfcRelSequence> >& IsSuccessorFrom_inverse = m_RelatedProcess->m_IsSuccessorFrom_inverse;
		for( auto it_IsSuccessorFrom_inverse = IsSuccessorFrom_inverse.begin(); it_IsSuccessorFrom_inverse != IsSuccessorFrom_inverse.end(); )
		{
			weak_ptr<IfcRelSequence> self_candidate_weak = *it_IsSuccessorFrom_inverse;
			if( self_candidate_weak.expired() )
			{
				++it_IsSuccessorFrom_inverse;
				continue;
			}
			shared_ptr<IfcRelSequence> self_candidate( *it_IsSuccessorFrom_inverse );
			if( self_candidate.get() == this )
			{
				it_IsSuccessorFrom_inverse= IsSuccessorFrom_inverse.erase( it_IsSuccessorFrom_inverse );
			}
			else
			{
				++it_IsSuccessorFrom_inverse;
			}
		}
	}
	if( m_RelatingProcess )
	{
		std::vector<weak_ptr<IfcRelSequence> >& IsPredecessorTo_inverse = m_RelatingProcess->m_IsPredecessorTo_inverse;
		for( auto it_IsPredecessorTo_inverse = IsPredecessorTo_inverse.begin(); it_IsPredecessorTo_inverse != IsPredecessorTo_inverse.end(); )
		{
			weak_ptr<IfcRelSequence> self_candidate_weak = *it_IsPredecessorTo_inverse;
			if( self_candidate_weak.expired() )
			{
				++it_IsPredecessorTo_inverse;
				continue;
			}
			shared_ptr<IfcRelSequence> self_candidate( *it_IsPredecessorTo_inverse );
			if( self_candidate.get() == this )
			{
				it_IsPredecessorTo_inverse= IsPredecessorTo_inverse.erase( it_IsPredecessorTo_inverse );
			}
			else
			{
				++it_IsPredecessorTo_inverse;
			}
		}
	}
}
