/* Code generated by IfcQuery EXPRESS generator, www.ifcquery.com */
#include "ifcpp/model/AttributeObject.h"
#include "ifcpp/model/BuildingException.h"
#include "ifcpp/model/BuildingGuid.h"
#include "ifcpp/reader/ReaderUtil.h"
#include "ifcpp/writer/WriterUtil.h"
#include "ifcpp/IFC4X3/include/IfcGloballyUniqueId.h"
#include "ifcpp/IFC4X3/include/IfcIdentifier.h"
#include "ifcpp/IFC4X3/include/IfcLabel.h"
#include "ifcpp/IFC4X3/include/IfcOwnerHistory.h"
#include "ifcpp/IFC4X3/include/IfcPropertySetDefinition.h"
#include "ifcpp/IFC4X3/include/IfcRelAggregates.h"
#include "ifcpp/IFC4X3/include/IfcRelAssigns.h"
#include "ifcpp/IFC4X3/include/IfcRelAssociates.h"
#include "ifcpp/IFC4X3/include/IfcRelDeclares.h"
#include "ifcpp/IFC4X3/include/IfcRelDefinesByType.h"
#include "ifcpp/IFC4X3/include/IfcRelNests.h"
#include "ifcpp/IFC4X3/include/IfcText.h"
#include "ifcpp/IFC4X3/include/IfcTypeObject.h"

// ENTITY IfcTypeObject 
IFC4X3::IfcTypeObject::IfcTypeObject( int tag ) { m_tag = tag; }
void IFC4X3::IfcTypeObject::getStepLine( std::stringstream& stream, size_t precision ) const
{
	stream << "#" << m_tag << "=IFCTYPEOBJECT" << "(";
	if( m_GlobalId ) { m_GlobalId->getStepParameter( stream, false, precision ); } else { stream << "$"; }
	stream << ",";
	if( m_OwnerHistory ) { stream << "#" << m_OwnerHistory->m_tag; } else { stream << "$"; }
	stream << ",";
	if( m_Name ) { m_Name->getStepParameter( stream, false, precision ); } else { stream << "$"; }
	stream << ",";
	if( m_Description ) { m_Description->getStepParameter( stream, false, precision ); } else { stream << "$"; }
	stream << ",";
	if( m_ApplicableOccurrence ) { m_ApplicableOccurrence->getStepParameter( stream, false, precision ); } else { stream << "$"; }
	stream << ",";
	writeEntityList( stream, m_HasPropertySets );
	stream << ");";
}
void IFC4X3::IfcTypeObject::getStepParameter( std::stringstream& stream, bool /*is_select_type*/, size_t /*precision*/ ) const { stream << "#" << m_tag; }
void IFC4X3::IfcTypeObject::readStepArguments( const std::vector<std::string>& args, const BuildingModelMapType<int,shared_ptr<BuildingEntity> >& map, std::stringstream& errorStream, std::unordered_set<int>& entityIdNotFound )
{
	const size_t num_args = args.size();
	if( num_args > 0 ){m_GlobalId = IfcGloballyUniqueId::createObjectFromSTEP( args[0], map, errorStream, entityIdNotFound );}
	if( num_args > 1 ){readEntityReference( args[1], m_OwnerHistory, map, errorStream, entityIdNotFound );}
	if( num_args > 2 ){m_Name = IfcLabel::createObjectFromSTEP( args[2], map, errorStream, entityIdNotFound );}
	if( num_args > 3 ){m_Description = IfcText::createObjectFromSTEP( args[3], map, errorStream, entityIdNotFound );}
	if( num_args > 4 ){m_ApplicableOccurrence = IfcIdentifier::createObjectFromSTEP( args[4], map, errorStream, entityIdNotFound );}
	if( num_args > 5 ){readEntityReferenceList( args[5], m_HasPropertySets, map, errorStream, entityIdNotFound );}
	if( num_args != 6 ){ errorStream << "Wrong parameter count for entity IfcTypeObject, expecting 6, having " << num_args << ". Entity ID: " << m_tag << std::endl; }
}
void IFC4X3::IfcTypeObject::getAttributes( std::vector<std::pair<std::string, shared_ptr<BuildingObject> > >& vec_attributes ) const
{
	IFC4X3::IfcObjectDefinition::getAttributes( vec_attributes );
	vec_attributes.emplace_back( std::make_pair( "ApplicableOccurrence", m_ApplicableOccurrence ) );
	shared_ptr<AttributeObjectVector> HasPropertySets_vec_object( new AttributeObjectVector() );
	std::copy( m_HasPropertySets.begin(), m_HasPropertySets.end(), std::back_inserter( HasPropertySets_vec_object->m_vec ) );
	vec_attributes.emplace_back( std::make_pair( "HasPropertySets", HasPropertySets_vec_object ) );
}
void IFC4X3::IfcTypeObject::getAttributesInverse( std::vector<std::pair<std::string, shared_ptr<BuildingObject> > >& vec_attributes_inverse ) const
{
	IFC4X3::IfcObjectDefinition::getAttributesInverse( vec_attributes_inverse );
	shared_ptr<AttributeObjectVector> Types_inverse_vec_obj( new AttributeObjectVector() );
	for( size_t i=0; i<m_Types_inverse.size(); ++i )
	{
		if( !m_Types_inverse[i].expired() )
		{
			Types_inverse_vec_obj->m_vec.emplace_back( shared_ptr<IfcRelDefinesByType>( m_Types_inverse[i] ) );
		}
	}
	vec_attributes_inverse.emplace_back( std::make_pair( "Types_inverse", Types_inverse_vec_obj ) );
}
void IFC4X3::IfcTypeObject::setInverseCounterparts( shared_ptr<BuildingEntity> ptr_self_entity )
{
	IfcObjectDefinition::setInverseCounterparts( ptr_self_entity );
	shared_ptr<IfcTypeObject> ptr_self = dynamic_pointer_cast<IfcTypeObject>( ptr_self_entity );
	if( !ptr_self ) { throw BuildingException( "IfcTypeObject::setInverseCounterparts: type mismatch" ); }
	for( size_t i=0; i<m_HasPropertySets.size(); ++i )
	{
		if( m_HasPropertySets[i] )
		{
			m_HasPropertySets[i]->m_DefinesType_inverse.emplace_back( ptr_self );
		}
	}
}
void IFC4X3::IfcTypeObject::unlinkFromInverseCounterparts()
{
	IfcObjectDefinition::unlinkFromInverseCounterparts();
	for( size_t i=0; i<m_HasPropertySets.size(); ++i )
	{
		if( m_HasPropertySets[i] )
		{
			std::vector<weak_ptr<IfcTypeObject> >& DefinesType_inverse = m_HasPropertySets[i]->m_DefinesType_inverse;
			for( auto it_DefinesType_inverse = DefinesType_inverse.begin(); it_DefinesType_inverse != DefinesType_inverse.end(); )
			{
				weak_ptr<IfcTypeObject> self_candidate_weak = *it_DefinesType_inverse;
				if( self_candidate_weak.expired() )
				{
					++it_DefinesType_inverse;
					continue;
				}
				shared_ptr<IfcTypeObject> self_candidate( *it_DefinesType_inverse );
				if( self_candidate.get() == this )
				{
					it_DefinesType_inverse= DefinesType_inverse.erase( it_DefinesType_inverse );
				}
				else
				{
					++it_DefinesType_inverse;
				}
			}
		}
	}
}
